<script setup lang="ts">
import router from '@/router'
import { type Ref, ref } from 'vue'
import { useAuthStore } from '@/stores/auth'
import { type User } from '@/types/User'
import { useMessageStore } from '@/stores/message'

const messageStore = useMessageStore()

const type = ref('password')

const dialog = ref(false)
const username = ref('admin')
const pass = ref('1234')
const authStore = useAuthStore()

async function navigateToMainMenu() {
  await authStore.login(username.value, pass.value)
  // await authStore.checkRole()

  // if (authStore.status === true) {
  //   // console.log(authStore.status)
  //   // console.log(username)
  //   // console.log(pass)
  //   dialog.value = false
  //   authStore.checkRole()
  //   authStore.changeAppBar()
  //   router.push({ name: 'mainmenu' })
  // } else {
  //   // console.log(username)
  //   // console.log(pass)
  //   // console.log(authStore.status)
  //   messageStore.showErrorLogin()
  // }
}

function changeType() {
  if (type.value == 'password') {
    type.value = ''
  } else {
    type.value = 'password'
  }
}

function byPassLogin() {
  dialog.value = false
  authStore.checkRole()
  router.push({ name: 'mainmenu' })
}
</script>

<template>
  <v-row justify="center">
    <v-dialog v-model="dialog" persistent width="1100" height="500">
      <template v-slot:activator="{ props }">
        <v-btn color="primary" v-bind="props" height="40px" width="150px"> Login </v-btn>
      </template>

      <v-row>
        <v-img height="500" width="550" src="\src\assets\Login\image1.jpg"> </v-img>

        <v-card width="480" height="495" color="white">
          <v-card-title Align="center">
            <h3 style="font-size: 50px; margin-top: 60px">Welcome</h3>
          </v-card-title>
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" md="13" class="mx-auto" style="margin-top: 30px">
                  <v-text-field
                    label="Username"
                    required
                    clearable
                    variant="outlined"
                    prepend-inner-icon="mdi-account"
                    v-model="username"
                    @keydown.enter="navigateToMainMenu()"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" md="13" class="mx-auto">
                  <v-text-field
                    label="Password"
                    :type="type"
                    required
                    clearable
                    variant="outlined"
                    prepend-inner-icon="mdi-lock-outline"
                    append-inner-icon="mdi-eye-outline"
                    @click:append-inner="changeType()"
                    @keydown.enter="navigateToMainMenu()"
                    v-model="pass"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
            <small class="text-caption text-decoration-none text-red"
              >Please enter your password.</small
            >
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn
              color="orange-darken-3"
              append-icon="mdi-close"
              variant="outlined"
              class="list-item-hover"
              @click="dialog = false"
              style="margin-top: 40px;"
            >
              Close
            </v-btn>
            <v-btn
              color="orange-darken-3"
              append-icon="mdi-arrow-right"
              variant="flat"
              class="list-item-hover"
              @click="navigateToMainMenu()"
              style="margin-top: 40px;"
            >
              Login
            </v-btn>

            <v-dialog v-model="messageStore.errorDialog" width="500px">
              <v-card>
                <br />
                <v-img
                  style="margin-left: 230px"
                  :width="40"
                  src="\src\assets\Login\icon.png"
                ></v-img>
                <v-spacer></v-spacer>
                <v-card-title align="center" class="text-h5">Login Failed</v-card-title>
                <v-card-title align="center" class="text-h10">
                  This action cannot be undone.<br />
                  You need to put correct password.
                </v-card-title>
                <v-spacer></v-spacer>
                <div align="center">
                  <div
                    style="
                      margin: 0 auto;
                      max-width: 400px;
                      border: 1px solid #dfe1e6;
                      border-radius: 5px;
                      margin-top: 10px;
                    "
                  >
                    <v-btn
                      block
                      color="primary"
                      variant="text"
                      @click="messageStore.closeErrorLogin()"
                    >
                      Cancel
                    </v-btn>
                  </div>
                </div>
                <v-spacer></v-spacer>
                <br />
              </v-card>
            </v-dialog>
          </v-card-actions>
        </v-card>
      </v-row>
    </v-dialog>
  </v-row>
</template>

<style scoped>
.list-item-hover:hover {
  transform: scale(1.03); /* Increase size by 5% on hover */
  box-shadow:
    0 1px 6px rgba(0, 0, 0, 0.1),
    0 1px 3px rgba(0, 0, 0, 0.08); /* Add a subtle box shadow */
}
</style>
